#!/usr/bin/env python
import numpy as np
import matplotlib.pyplot as plt
from MITgcmutils import rdmds
from myutils import *


# 1st upwind
t1 = np.squeeze(rdmds('run80/T',np.NaN)).transpose()
# 2nd flux limiter
t77 = np.squeeze(rdmds('run80/S',np.NaN)).transpose()
# 3rd DST Flux limiter
t33 = np.squeeze(rdmds('run81/T',np.NaN)).transpose()
# 7th MP
t7 = np.squeeze(rdmds('run81/S',np.NaN)).transpose()

x = np.squeeze(rdmds('XC'))/1000.

# rectangle:
xx=x
tt=t1[:,0]
xx=np.insert(xx,8,xx[8])
tt=np.insert(tt,8,tt[7])
xx=np.insert(xx,13,xx[12])
tt=np.insert(tt,13,tt[13])

# add overlap
x = np.hstack((x-200.,x,x+200.))
xx = np.hstack((xx-200.,xx,xx+200.))
tt = np.hstack((tt,tt,tt))
t1 = np.vstack((t1,t1,t1))
t77 = np.vstack((t77,t77,t77))
t33 = np.vstack((t33,t33,t33))
t7 = np.vstack((t7,t7,t7))


lst = ['k-','k-.','k.-','k--','kx-']
lst = ['k-','-.','.-','--','x-']
fh=plt.figure()
fh.clf();
ax = fh.add_subplot(211)
plt.plot(x,t1[:,0],lst[0],label='initial')
plt.plot(x,t1[:,1],lst[1],label='80')
plt.plot(x,t77[:,1],lst[2],label='80')
plt.plot(x,t33[:,1],lst[3],label='81')
plt.plot(x,t7[:,1],lst[4],label='81')
#plt.legend(loc = 'best',prop={'size':12})
plt.legend(loc=1,prop={'size':10})
plt.text(10,0.85,'after 200 km')
plt.ylabel('ice thickness (meters)')
bx = fh.add_subplot(212)
plt.plot(x,t1[:,0],lst[0],label='initial')
plt.plot(x,t1[:,-1],lst[1],label='1st upwind')
plt.plot(x,t77[:,-1],lst[2],label='2nd flux lim.')
plt.plot(x,t33[:,-1],lst[3],label='3rd flux lim.')
plt.plot(x,t7[:,-1],lst[4],label='7th mp')
plt.text(10,0.85,'after 2000 km')
plt.ylabel('ice thickness (meters)')
plt.xlabel('horizontal distance (kilometers)')

axes = [ax, bx]
for axitem in axes: 
    axitem.set_xlim([0, 200])
    axitem.set_ylim([-1.2, 1.2])
    axitem.grid(True,color='gray')

#fh.savefig('advection_schemes_bw.eps',format='eps')
fh.savefig('advection_schemes.eps',format='eps')
plt.show()
